 	 
/*
     This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; version 2 of the License.
   
     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.

*/

#include <stdlib.h>
#include <string.h>

#include "SDL.h"    
#include "SDL_mixer.h" 
#include "menu.h"
#define GP33


#define	SCREEN_W	320
#define	SCREEN_H	240

#define blocW 15
#define blocH 15

typedef struct
{
  int px,py;
  int vx,vy;
  int mol;
   int mod;
  int target;
} fitxa;

typedef struct
{
int mol;
   int mod;
} sol;

typedef struct
{
  sol MatriuSol[10][10];
  fitxa MatriuJoc[15][15];
  int level;
  int temps;
  int MovX,MovY;

} tauler;

typedef struct
{
	float		pos_x, pos_y; 
	float		vel_x, vel_y; 

	SDL_Surface	*tiles;
} tiled_layer_t;

typedef struct
{
int x;
int y;
SDL_Surface	*img;
} cursor;

int modeMusic=0;
int track=3;
char str[100];
int movs=0;
int	temps=0;

/*
 * Size of one background tile in pixels
 */
#define	TILE_W		48
#define	TILE_H		48

 	Mix_Music *Music;
int MVolume=128;
int SVolume=128;

int nivell=1; 
	SDL_Surface	*font;

void getFriend( tauler *t);	

void carragarNivell(int l, tauler *t)
{
  int i, j, seektarget=0;
  FILE *levelfile = stdin;

  if ((levelfile = fopen ("./gpmm/atomigfx/fa.dat", "rb")) == NULL) 	printf("error");

  fseek (levelfile, 975 *  l, SEEK_SET);

  for (i = 0; i < 15; i++)
  {  for (j = 0; j < 15; j++)
		{int obj;
		unsigned int verb;
		obj = fgetc (levelfile);
		verb = fgetc (levelfile); verb += (fgetc (levelfile) << 8);
	   	t->MatriuJoc[i][j].mol=obj;
		t->MatriuJoc[i][j].mod=verb;

		if (obj==254) t->MatriuJoc[i][j].mol=-2;
		else	if (obj==0) t->MatriuJoc[i][j].mol=-1;
				else{ if (seektarget==0){
					t->MatriuJoc[i][j].target=1;
					seektarget=1;}
					}

		}
   }

	fclose (levelfile);
	getFriend(t);
}



void carragar_solucio(int l, tauler *t)
{
  int i, j;
  FILE *levelfile = stdin;


  if ((levelfile = fopen ("./gpmm/atomigfx/fa.dat", "rb")) == NULL)
    printf("Error");

  fseek (levelfile, 975 * (long) l + 675, SEEK_SET);
  
  // molekle einlesen  
  for (i = 0; i < 10; i++)
  {
	for (j = 0; j < 10; j++)
	{ int obj;
		unsigned int verb;

		obj = fgetc (levelfile);
		verb = fgetc (levelfile);
		verb += (fgetc (levelfile) << 8);


	t->MatriuSol[i][j].mol=obj;
	t->MatriuSol[i][j].mod=verb;

	}
  }
	fclose (levelfile);
}

void iniciar_tauler(tauler *t)
{ int i,j;

movs=0;
t->MovX=-1;
t->MovY=-1;
	for (i=0;i<15;i++)
		for (j=0;j<15;j++)
		{
			t->MatriuJoc[i][j].mol=-1;
			t->MatriuJoc[i][j].mod=-1;
			t->MatriuJoc[i][j].px=0;
			t->MatriuJoc[i][j].py=0;
			t->MatriuJoc[i][j].vx=0;
			t->MatriuJoc[i][j].vy=0;
			t->MatriuJoc[i][j].target=0;			
			if (i==0 || i==14 || j==0 || j==14)  // Aixo ho podria treure pero paso
			t->MatriuJoc[i][j].mol=-2;
		}
		
}



void DrawIMG(SDL_Surface *img,SDL_Surface *screen, int x, int y)
{
SDL_Rect dest;
dest.x = x;
dest.y = y;
 SDL_SetColorKey(img, SDL_SRCCOLORKEY,
		 SDL_MapRGB(img->format, 255,255,255));
 
SDL_BlitSurface(img, NULL, screen, &dest);
}


void DrawI(SDL_Surface *img,SDL_Surface *screen, int sx, int sy,int w, int h ,int dx, int dy) //Tambe pillen l'oigen i w,h
{

SDL_Rect dest;
SDL_Rect orig;

orig.x = sx; orig.y = sy;
orig.w = w; orig.h = h;

dest.x = dx; dest.y = dy;

SDL_SetColorKey(img, SDL_SRCCOLORKEY,
		 SDL_MapRGB(img->format, 0,0,0));
SDL_BlitSurface(img, &orig, screen, &dest);
}


void DibuixarTauler(SDL_Surface *screen, cursor *c , SDL_Surface *atomicBoard, tauler *t,SDL_Surface *fletxa, int nivell)
{ int i,j;
static int abac=0;
abac++;
 for(i=14;i>=0;i--)
   for(j=0;j<15;j++)
   {
  
    if (t->MatriuJoc[i][j].mol==-2)
    {
    if (nivell<20)
     DrawI( atomicBoard,  screen, 211-20, 43, 20, 20, 5+i*blocW+t->MatriuJoc[i][j].px, 10+j*blocH+t->MatriuJoc[i][j].py);
    if (nivell>=20 && nivell <40)
     DrawI( atomicBoard,  screen, 211-40, 43, 20, 20, 5+i*blocW+t->MatriuJoc[i][j].px, 10+j*blocH+t->MatriuJoc[i][j].py);    
    if (nivell>=40)
 DrawI( atomicBoard,  screen, 211, 43, 20, 20, 5+i*blocW+t->MatriuJoc[i][j].px, 10+j*blocH+t->MatriuJoc[i][j].py);        
     }
     

 
   if (t->MatriuJoc[i][j].mol!=-1 && t->MatriuJoc[i][j].mol<20)
   {
     DrawI( atomicBoard,  screen, 0+(t->MatriuJoc[i][j].mol-1)*15, 0, 15, 15, 10+i*blocW+t->MatriuJoc[i][j].px,	  10+j*blocH+t->MatriuJoc[i][j].py);
	}else
	{
	if (t->MatriuJoc[i][j].mol==20)
     DrawI( atomicBoard,  screen, 0+(t->MatriuJoc[i][j].mol-10)*15, 0, 15, 15, 10+i*blocW+t->MatriuJoc[i][j].px,	  10+j*blocH+t->MatriuJoc[i][j].py);

	if (t->MatriuJoc[i][j].mol>=30)
     DrawI( atomicBoard,  screen, 0+(t->MatriuJoc[i][j].mol-20+1)*15, 0, 15, 15, 10+i*blocW+t->MatriuJoc[i][j].px,	  10+j*blocH+t->MatriuJoc[i][j].py);
	}	
	
	//if (abac%2==0)
	if (t->MatriuJoc[i][j].target==1)
	{

	 if (t->MatriuJoc[i][j].vy==0)
	 { 
	  if (t->MatriuJoc[i-1][j].mol==-1) 	DrawI(fletxa,screen,0,0,15,15, 10+i*blocW+t->MatriuJoc[i][j].px-15, 10+j*blocH+t->MatriuJoc[i][j].py);
	  if (t->MatriuJoc[i+1][j].mol==-1) 	DrawI(fletxa,screen,30,0,15,15, 10+i*blocW+t->MatriuJoc[i][j].px+15, 10+j*blocH+t->MatriuJoc[i][j].py);

	}

	 if (t->MatriuJoc[i][j].vx==0)
	 { 
	  if (t->MatriuJoc[i][j-1].mol==-1) 	DrawI(fletxa,screen,15,0,14,15, 10+i*blocW+t->MatriuJoc[i][j].px, 10-15+j*blocH+t->MatriuJoc[i][j].py);
	  if (t->MatriuJoc[i][j+1].mol==-1) 	DrawI(fletxa,screen,45,0,14,15, 10+i*blocW+t->MatriuJoc[i][j].px, 10+15+j*blocH+t->MatriuJoc[i][j].py);

	}	  

	DrawIMG(c->img,screen, 10+i*blocW+t->MatriuJoc[i][j].px,  10+j*blocH+t->MatriuJoc[i][j].py);
	  	  
	}
	
	if (t->MatriuJoc[i][j].mod!=-1)
	    {  int anz;     
      for ( anz = 0; anz < 16; anz++)
        if ((t->MatriuJoc[i][j].mod & (1 << anz)) == (unsigned int) (1 << anz))
        {
          if (anz < 8)
		      DrawI( atomicBoard,  screen, 0+anz*15, 15, 15, 15, 10+i*blocW+t->MatriuJoc[i][j].px,10+j*blocH+t->MatriuJoc[i][j].py);
          else
			DrawI( atomicBoard,  screen, 0+(anz-8)*15, 33, 15, 15, 10+i*blocW+t->MatriuJoc[i][j].px,10+j*blocH+t->MatriuJoc[i][j].py);
        }
    }

	
	}
	
			sprintf(str,"Movs %d", (movs));
		SDL_print(str,270,210,font,screen);

}

void DibuixarSolucio(SDL_Surface *screen, SDL_Surface *atomicBoard, tauler *t)
{ int i,j;
	 for(i=0;i<10;i++)
		for(j=0;j<10;j++)
		{
		
	

	
		   if (t->MatriuSol[i][j].mol!=0 && t->MatriuSol[i][j].mol<20)
		   {
			DrawI( atomicBoard,  screen, 0+(t->MatriuSol[i][j].mol-1)*15, 0, 15, 15, 10+i*blocW+0,10+j*blocH+0);
			}else
			{
				if (t->MatriuSol[i][j].mol==20 && t->MatriuSol[i][j].mol!=0)
			DrawI( atomicBoard,  screen, 0+(t->MatriuSol[i][j].mol-10)*15, 0, 15, 15, 10+i*blocW+0,10+j*blocH+0);
			
			if (t->MatriuSol[i][j].mol>=30)
			DrawI( atomicBoard,  screen, 0+(t->MatriuSol[i][j].mol-20+1)*15, 0, 15, 15, 10+i*blocW,	  10+j*blocH);
	
			}
			
			
		if (t->MatriuSol[i][j].mod!=-1)
			{  int anz;     
			for ( anz = 0; anz < 16; anz++)
				if ((t->MatriuSol[i][j].mod & (1 << anz)) == (unsigned int) (1 << anz))
				{
					if (anz < 8) DrawI( atomicBoard,  screen, 0+anz*blocW, blocH, 15, 15, 10+i*blocW+0,10+j*blocH+0);
					else DrawI( atomicBoard,  screen, 0+(anz-8)*15, blocH*2+3, 15, 15, 10+i*blocW+0,10+j*blocH+0);
				}
			}
		}
		
				char stringit[100];
 
		sprintf(stringit,"Level %d", (1+nivell));
		SDL_print(stringit,10,140,font,screen);
		SDL_print(molec[nivell],20,150,font,screen);

}


void ActualitzarTauler(tauler *t)  // Tela
{ int i,j;

if (t->MovY!=-1)
{
i=t->MovX;
j=t->MovY;
}
// for(i=1;i<14;i++)
  // for(j=1;j<14;j++)
   {

		if (t->MatriuJoc[i][j].px==0)
		{
			if (t->MatriuJoc[i][j].vx==1)
			{
				if (t->MatriuJoc[i+1][j].mol==-1)
					t->MatriuJoc[i][j].px+=	t->MatriuJoc[i][j].vx;
				else
					t->MatriuJoc[i][j].vx=0;
			 }


			if (t->MatriuJoc[i][j].vx==-1)
			{
				if (t->MatriuJoc[i-1][j].mol==-1)
					t->MatriuJoc[i][j].px+=	t->MatriuJoc[i][j].vx;
				else
					t->MatriuJoc[i][j].vx=0;
			  }



		
		} else
		{ 		
			if (t->MatriuJoc[i][j].vx==1)
			 {
				if (t->MatriuJoc[i][j].px>7)
					{
				t->MatriuJoc[i][j].px=0;
				t->MatriuJoc[i][j].vx=0;
				t->MatriuJoc[i+1][j].px=-7;
				t->MatriuJoc[i+1][j].mol=t->MatriuJoc[i][j].mol;
				t->MatriuJoc[i+1][j].mod=t->MatriuJoc[i][j].mod;
				t->MatriuJoc[i+1][j].target=1;
				t->MatriuJoc[i][j].target=0;
				t->MatriuJoc[i][j].mod=-1;
				t->MatriuJoc[i][j].mol=-1;
				t->MatriuJoc[i+1][j].vx=1;
				t->MovX++;

				} else 			t->MatriuJoc[i][j].px+=t->MatriuJoc[i][j].vx;
			}
			
			if (t->MatriuJoc[i][j].vx==-1)
			 {
				if (t->MatriuJoc[i][j].px<-7)
					{
				t->MatriuJoc[i][j].px=0;
				t->MatriuJoc[i][j].vx=0;
				t->MatriuJoc[i-1][j].px=7;
				t->MatriuJoc[i-1][j].mol=t->MatriuJoc[i][j].mol;
				t->MatriuJoc[i-1][j].mod=t->MatriuJoc[i][j].mod;
				t->MatriuJoc[i-1][j].target=1;
				t->MatriuJoc[i][j].target=0;
				t->MatriuJoc[i][j].mod=-1;
				t->MatriuJoc[i][j].mol=-1;
				t->MatriuJoc[i-1][j].vx=-1;
				t->MovX--;
				} else 			t->MatriuJoc[i][j].px+=t->MatriuJoc[i][j].vx;
						
			}
			
		}
		
		if (t->MatriuJoc[i][j].py==0)
		{
			if (t->MatriuJoc[i][j].vy==1)
			{
				if (t->MatriuJoc[i][j+1].mol==-1)
					t->MatriuJoc[i][j].py+=	t->MatriuJoc[i][j].vy;
				else
					t->MatriuJoc[i][j].vy=0;
			}

 
			if (t->MatriuJoc[i][j].vy==-1)
			{
				if (t->MatriuJoc[i][j-1].mol==-1)
					t->MatriuJoc[i][j].py+=	t->MatriuJoc[i][j].vy;
				else
					t->MatriuJoc[i][j].vy=0;
					
					}



		
		} else
		{ 		
			if (t->MatriuJoc[i][j].vy==1)
			 {
				if (t->MatriuJoc[i][j].py>7)
					{
				t->MatriuJoc[i][j].py=0;
				t->MatriuJoc[i][j].vy=0;
				t->MatriuJoc[i][j+1].py=-7;
				t->MatriuJoc[i][j+1].mol=t->MatriuJoc[i][j].mol;
				t->MatriuJoc[i][j+1].mod=t->MatriuJoc[i][j].mod;
				t->MatriuJoc[i][j+1].target=1;
				t->MatriuJoc[i][j].target=0;
				t->MatriuJoc[i][j].mod=-1;
				t->MatriuJoc[i][j].mol=-1;
				t->MatriuJoc[i][j+1].vy=1;
				t->MovY++;

				} else 			t->MatriuJoc[i][j].py+=t->MatriuJoc[i][j].vy;
			}
			
			if (t->MatriuJoc[i][j].vy==-1)
			 {
				if (t->MatriuJoc[i][j].py<-7)
					{
				t->MatriuJoc[i][j].py=0;
				t->MatriuJoc[i][j].vy=0;
				t->MatriuJoc[i][j-1].py=7;
				t->MatriuJoc[i][j-1].mol=t->MatriuJoc[i][j].mol;
				t->MatriuJoc[i][j-1].mod=t->MatriuJoc[i][j].mod;
				t->MatriuJoc[i][j-1].target=1;
				t->MatriuJoc[i][j].target=0;
				t->MatriuJoc[i][j].mod=-1;
				t->MatriuJoc[i][j].mol=-1;
				t->MatriuJoc[i][j-1].vy=-1;
				t->MovY--;

				} else 			t->MatriuJoc[i][j].py+=t->MatriuJoc[i][j].vy;
						
			}
			
		}
		
	}
}

void DibuixarCursor(cursor *c,  SDL_Surface *scree)
{
		
DrawIMG(c->img,scree, 10+16*(c->x),50+16*(c->y));

}


void automagic(int x, int y, tauler *t)
{
int i,j;
 for(i=1;i<14;i++)
   for(j=1;j<14;j++)
	{
		if (t->MatriuJoc[i][j].target==1)
			{
				if ((t->MatriuJoc[i][j].vx==0)&&(t->MatriuJoc[i][j].vy==0)) 
				{
				if(t->MatriuJoc[i+x][j+y].mol==-1)
					movs++;
				}
				if (x!=0) if(t->MatriuJoc[i][j].vy==0) t->MatriuJoc[i][j].vx=x;

				if (y!=0) if(t->MatriuJoc[i][j].vx==0) t->MatriuJoc[i][j].vy=y;
				
				t->MovX=i;
				t->MovY=j;

			}
	
	}

}


void getFriend( tauler *t)
{
int i,j;
 for(i=1;i<14;i++)
   for(j=1;j<14;j++)
	{
		if (t->MatriuJoc[i][j].target==1)
			{
		
				t->MovX=i;
				t->MovY=j;

			}
	
	}

}
void draw_fons(SDL_Surface *screen, SDL_Surface *fons, int x, int y)
{
	SDL_Rect source_rect, dest_rect;



	source_rect.x = 0;	/* Only one column, so we never change this. */
	source_rect.y = 0;	/* Select tile from image! */
	source_rect.w = 320;
	source_rect.h = 240;

	dest_rect.x = x;
	dest_rect.y = y;

	SDL_BlitSurface(fons, &source_rect, screen, &dest_rect);
}

void draw_tile(SDL_Surface *screen, SDL_Surface *tiles, int x, int y, char tile)
{
	SDL_Rect source_rect, dest_rect;

	/* Study the following expression. Typo trap! :-) */
	if(' ' == tile)
		return;

	source_rect.x = 0;	/* Only one column, so we never change this. */
	source_rect.y = (tile - '0') * TILE_H;	/* Select tile from image! */
	source_rect.w = TILE_W;
	source_rect.h = TILE_H;

	dest_rect.x = x;
	dest_rect.y = y;

	SDL_BlitSurface(tiles, &source_rect, screen, &dest_rect);
}

void targetplus(tauler *t, int k)
{ int fase;
int i,j;

fase=0;

if(k==0)
{

while(fase!=2)
 for(i=1;i<14;i++)
   for(j=1;j<14;j++)
	{
	if (fase==1) if (t->MatriuJoc[i][j].mol>0) { fase=2; t->MatriuJoc[i][j].target=1; goto end;}

	if (fase==0) 
     if (t->MatriuJoc[i][j].target==1)
          {
          	 if (t->MatriuJoc[i][j].vx==0 && t->MatriuJoc[i][j].vy==0)
          	 	 { fase=1; t->MatriuJoc[i][j].target=0;}
          	 	 	  else {fase=2; goto end;}
	  }
	}

} else
{

while(fase!=2)
 for(i=14;i>=1;i--)
   for(j=14;j>=1;j--)
	{

  	if (fase==1) if (t->MatriuJoc[i][j].mol>0) { fase=2; t->MatriuJoc[i][j].target=1; goto end; }

	if (fase==0) 
     if (t->MatriuJoc[i][j].target==1)
          {
          	 if (t->MatriuJoc[i][j].vx==0 && t->MatriuJoc[i][j].vy==0)
          	 	 { fase=1; t->MatriuJoc[i][j].target=0;}
          	 	 	  else {fase=2; goto end;}
		  }
	  

	}

}
end:;

}


int comprovar_actual(tauler *t, int k, int l) // 1..15, 1..15
{ int i,j;
for (i=0; i<10; i++)
	for (j=0; j<10; j++)
	{

	
	if ( ((i+k)>15) || ((j+l)>15))
	{


		if (t->MatriuSol[i][j].mol!=0) {  return -1;}
	}
	else{

		
		if (t->MatriuSol[i][j].mol==0)
		{/*
				if ( (t->MatriuJoc[i+k][i+l].mol!=-1) && (t->MatriuJoc[i+k][i+l].mol!=-2)) //algo passa amb aixo per *crec* que es pot ignorar
				{ printf ("sol1(%d %d %d) ",k,l,t->MatriuJoc[i+k][i+l].mol); return -1;}*/
		}else
		{
		
		if (t->MatriuJoc[i+k][j+l].mol!=t->MatriuSol[i][j].mol) 
		{  return -1;}
		if (t->MatriuJoc[i+k][j+l].mod!=t->MatriuSol[i][j].mod) { /*printf ("sol3(%d %d) ",k,l);*/ return -1;}
		}
		}
	}
	
	return 1;

}
  //		1 .. 15
  //		   1 ..  10
  
void EdinyarSolucio(SDL_Surface *screen, SDL_Surface *screenSol, int l)
{
DrawI(screenSol, screen, 
0,0,
l,170,
320-l,0);

}
  
int comprovar_solucio(tauler *t)
{ int i,j;

for (i=0; i<15; i++)
	for (j=0; j<15; j++)
		if(t->MatriuJoc[i][j].vx!=0 || t->MatriuJoc[i][j].vy!=0) return -1;


for (i=0; i<15; i++)
	for (j=0; j<15; j++)
		{
	//	printf("comprovant .. (%d %d)\n",i,j); 
		
		if (comprovar_actual(t, i,j)==1) 
			{
	//		printf("bona!\n");
			return 1;
			}
		}
		return -1;			

}

#ifdef GP32
void setCPUSpeed( long mclk, int fac, int div) {
asm volatile(""
 "mov r0,%0   \n"
 "mov r1,%1   \n"
 "mov r2,%2   \n"
 "stmdb sp!,{r0,r1,r2,lr} \n"
 "mov r0,sp   \n"
 "swi #0x0d   \n"
 "add sp,sp,#12  \n"
 "ldmia sp!,{lr}"
 :
 : "r"(mclk),"r"(fac),"r"(div)
 : "r0","r1","r2");
}
#endif

void LoadMusic(int num)
{

Mix_FreeMusic(Music);
sprintf(str,"./GPMM/atomigfx/snd/%d.s3m",num);

Music = Mix_LoadMUS(str);

}
void MusicLoopback(void){
if (modeMusic==0) 
{track++;
if (track>7) track=1;
LoadMusic(track);
}
//    printf("Module finished...\n");
    Mix_PlayMusic(Music,0);
    Mix_VolumeMusic(MVolume);

}


int main(int argc, char* argv[])
{

#ifdef GP32
	setCPUSpeed (66000000, 0x3a012, 0);
#endif

	iniciarFets();
	carragarFets();

	int frame=0;
	SDL_Surface	*screen;
	SDL_Surface	*screenSol;

	SDL_Surface	*fons_bmp;
	SDL_Surface	*fons;
	SDL_Surface	*font_bmp;

	SDL_Surface	*fletxa_bmp;
	SDL_Surface	*fletxa;

	SDL_Surface	*atoms3_bmp;
	SDL_Surface	*atoms3;
	
	SDL_Surface     *satomic;
	SDL_Surface     *atomic_bmp;

	SDL_Surface		*cursor_bmp;
	tiled_layer_t	background_layer;

	long tick1, tick2; float dt;
	SDL_Event event;
	int	flags = 0;
	tauler t;
	cursor cur; 	int keyDown=0; int bisagra=100;
antemenu:
	iniciar_tauler(&t);


	carragar_solucio(nivell, &t);
	carragarNivell(nivell, &t);
	

	SDL_Init(SDL_INIT_VIDEO|SDL_INIT_AUDIO);

	atexit(SDL_Quit);
    Mix_OpenAudio(22050, AUDIO_S16, 1, 1024);

 
	screen = SDL_SetVideoMode(SCREEN_W, SCREEN_H, 16, flags);
	SDL_ShowCursor(SDL_DISABLE);
	//SDL_WM_SetCaption("Atomic", "Atomic");



	fons_bmp = SDL_LoadBMP("./gpmm/atomigfx/fons.bmp"); fons = SDL_DisplayFormat(fons_bmp); SDL_FreeSurface(fons_bmp);
	font_bmp = SDL_LoadBMP("./gpmm/atomigfx/font.bmp");	font = SDL_DisplayFormat(font_bmp);	SDL_FreeSurface(font_bmp);	
	atomic_bmp = SDL_LoadBMP("./gpmm/atomigfx/atomic.bmp");	satomic = SDL_DisplayFormat(atomic_bmp); SDL_FreeSurface(atomic_bmp);
	fletxa_bmp = SDL_LoadBMP("./gpmm/atomigfx/fletxa.bmp");	fletxa = SDL_DisplayFormat(fletxa_bmp); SDL_FreeSurface(fletxa_bmp);


	SDL_SetColorKey(satomic, SDL_SRCCOLORKEY|SDL_RLEACCEL, SDL_MapRGB(satomic->format,0,0,0));
	
 
	cursor_bmp = SDL_LoadBMP("./gpmm/atomigfx/cursor.bmp"); cur.img = SDL_DisplayFormat(cursor_bmp); SDL_FreeSurface(cursor_bmp);	

	SDL_FreeSurface(fons);
	fons_bmp = SDL_LoadBMP("./gpmm/atomigfx/start.bmp"); fons = SDL_DisplayFormat(fons_bmp);	SDL_FreeSurface(fons_bmp);


	atoms3_bmp = SDL_LoadBMP("./gpmm/atomigfx/3atoms.bmp");	atoms3 = SDL_DisplayFormat(atoms3_bmp);	SDL_FreeSurface(atoms3_bmp);	


	// Activar Musica
	LoadMusic(1);
	Mix_VolumeMusic(100);
    Mix_Volume(-1,SVolume);
    Mix_HookMusicFinished(&MusicLoopback);
    Mix_VolumeMusic(MVolume);
    Mix_FadeInMusic(Music,0,3000);
  
  

	intro(screen,  atoms3, fons);



	SDL_FreeSurface(fons); fons_bmp = SDL_LoadBMP("./gpmm/atomigfx/menu.bmp"); fons = SDL_DisplayFormat(fons_bmp); SDL_FreeSurface(fons_bmp);


	nivell=0; // Carragem el primer nivell
	iniciar_tauler(&t);
	carragar_solucio(nivell, &t);
	carragarNivell(nivell, &t);

menu: ; // Un label?		
		
	int opcio = dibuixarMenu(screen, fons, atoms3, font); // Menu de Inici

int saltar=0;
if (opcio==3)
{
guardarFets();
opcio=0;
goto menu;
}

if (opcio==5)
{
guardarFets();
exit(0);
}


if (opcio==0) goto joc;		
if (opcio==2)
{

while (opcio!=-1)
	{	if (opcio==0)
		modeMusic=0;
		else
		{LoadMusic(opcio);  MusicLoopback(); modeMusic=1;}
		opcio=dibuixarMenu2(screen, fons, atoms3, font);

	}
	

opcio=1;
	SDL_Delay(1000);
	
	goto menu;	

}
if (opcio==4)
{credit();
goto antemenu;
}

if (opcio==1)
{
opcio=0;


	opcio=dibuixarMenu3(screen, fons, satomic, font);
}

		nivell=opcio;

		iniciar_tauler(&t);
		carragar_solucio(nivell, &t);
		carragarNivell(nivell, &t);

joc:	

	fletxa_bmp = SDL_LoadBMP("./gpmm/atomigfx/sol.bmp");
	screenSol = SDL_DisplayFormat(fletxa_bmp);


 DibuixarSolucio(screenSol, satomic, &t);
 
 


	while (SDL_PollEvent(&event) >= 0)
	{
	
	if(comprovar_solucio(&t)==1) 
	{
		fet(nivell, movs);


		nivell++;
		
		
		SDL_FreeSurface(fons); fons_bmp = SDL_LoadBMP("./gpmm/atomigfx/lvlup.bmp"); fons = SDL_DisplayFormat(fons_bmp); SDL_FreeSurface(fons_bmp);
	int i;
	float x=100,y=100;
	
	for(i=0;i<100;i++)
	{
	x+=cos(((float)i*100))*50;
	y+=cos(((float)i*100))*50;
   		draw_fons(screen, fons, 0, 0);	
		DrawI( atoms3,  screen, 0+30, 0, 30, 30, x, y);
		SDL_Flip(screen);
		SDL_Delay(1);
	}

if (nivell>=67)
{
		SDL_FreeSurface(fons); fons_bmp = SDL_LoadBMP("./gpmm/atomigfx/fi.bmp"); fons = SDL_DisplayFormat(fons_bmp); SDL_FreeSurface(fons_bmp);

{
   		draw_fons(screen, fons, 0, 0);	
		
		SDL_Flip(screen);

		SDL_Delay(5000);
}

nivell =1;
}

		SDL_FreeSurface(fons); fons_bmp = SDL_LoadBMP("./gpmm/atomigfx/menu.bmp"); fons = SDL_DisplayFormat(fons_bmp); SDL_FreeSurface(fons_bmp);

		iniciar_tauler(&t);
		carragar_solucio(nivell, &t);
		carragarNivell(nivell, &t);
		fletxa_bmp = SDL_LoadBMP("./gpmm/atomigfx/sol.bmp");
		screenSol = SDL_DisplayFormat(fletxa_bmp);
		SDL_FreeSurface(fletxa_bmp);

		DibuixarSolucio(screenSol, satomic, &t);
 	}

		frame++;
		if (event.type == SDL_MOUSEBUTTONDOWN)
			break;

		if (getThisKey(event)!=0)
		{ if (getThisKey(event)!=0)
		
		if (keyDown==0)
			switch(getThisKey(event))
			{
			case RIGHTKEY:
				automagic(1,0,&t); break;
			case LEFTKEY:
				automagic(-1,0,&t); break;
			case UPKEY:
				automagic(0,-1,&t); break;
			case DOWNKEY:
				automagic(0,1,&t); break;							
			case STKEY:
				targetplus(&t,1); break;
			case SEKEY:
				targetplus(&t,0); break;
		case LKEY:
		/*
		nivell++;
		iniciar_tauler(&t);
		carragar_solucio(nivell, &t);
		carragarNivell(nivell, &t);
		screenSol = SDL_DisplayFormat(fletxa_bmp);

		DibuixarSolucio(screenSol, satomic, &t);
 		*/
			   break;
				
			}
			switch(getThisKey(event))
			{
	
			case AKEY:
				bisagra++; break;
			case BKEY:
				bisagra--;	break;	
				
			}
				
		keyDown=1;
		} else {keyDown=0;}

		Uint8 *keys;
		keys=SDL_GetKeyState(NULL);
		
  if(keys[SDLK_TAB]&&keys[SDLK_BACKSPACE])
  { goto menu;
  }
  
  
		if(keys[SDLK_RETURN]&&keys[SDLK_BACKSPACE])
		{
		iniciar_tauler(&t);
		carragar_solucio(nivell, &t);
		carragarNivell(nivell, &t);
		fletxa_bmp = SDL_LoadBMP("./gpmm/atomigfx/sol.bmp");
		screenSol = SDL_DisplayFormat(fletxa_bmp);
		SDL_FreeSurface(fletxa_bmp);
		DibuixarSolucio(screenSol, satomic, &t);
		}		
		








		


		temps++;
 


	ActualitzarTauler(&t);

  if (temps%2==0)
    {
   		draw_fons(screen, fons, 0, 0);
		DibuixarTauler(screen, &cur,  satomic, &t,fletxa, nivell);
	
   		EdinyarSolucio(screen,screenSol, bisagra);
		
		SDL_Flip(screen);

		SDL_Delay(1);
		}

	}

 

	exit(0);
}



void SDL_print2(char *c, int x, int y, SDL_Surface *fnt, SDL_Surface *screen)
{ int n;
n=0;

while(c[n]!='\0')
	if (c[n]>96 && c[n]<(96+27))
	{
		SDL_Rect orig;
		orig.x = 8*(c[n]-97);
		orig.y = 0;
		orig.h=24;
		orig.w=8;
		
		SDL_Rect dest;
		dest.x = x+8*n;
		dest.y = y;

 SDL_SetColorKey(fnt, SDL_SRCCOLORKEY,
		 SDL_MapRGB(fnt->format, 255,255,255));		
		SDL_BlitSurface(fnt, &orig, screen, &dest);
		n++;
	} else 
	if (c[n]>=65 && c[n]<(65+27))
	{
		SDL_Rect orig;
		orig.x = 8*(c[n]-65+26);
		orig.y = 0;
		orig.h=24;
		orig.w=8;
		
		SDL_Rect dest;
		dest.x = x+8*n;
		dest.y = y;

 SDL_SetColorKey(fnt, SDL_SRCCOLORKEY,
		 SDL_MapRGB(fnt->format, 255,255,255));		
		SDL_BlitSurface(fnt, &orig, screen, &dest);
		n++;
	}
	else if(c[n]>=48 && c[n]<=(48+10))
	{
		SDL_Rect orig;
		orig.x = 8*(c[n]-49+26+26);
		orig.y = 0;
		orig.h=24;
		orig.w=8;
		
		SDL_Rect dest;
		dest.x = x+8*n;
		dest.y = y;

 SDL_SetColorKey(fnt, SDL_SRCCOLORKEY,
		 SDL_MapRGB(fnt->format, 255,255,255));		
		SDL_BlitSurface(fnt, &orig, screen, &dest);
		n++;
			
	
	}
	else n++;
   
}

int credit(void)
{
printf("credit");
//#ifdef GP32
setCPUSpeed (132000000, 0x3a012, 0);
//#endif

	
	int frame=0;
	
	SDL_Surface	*screen;

	SDL_Surface	*fons_bmp;
	SDL_Surface	*fons, *aura, *aura_bmp, *nau, *nau_bmp, *credit, *credit_bmp, *tiron, *tiron_bmp;
	SDL_Surface	*font_bmp, *font, *tiro, *tiro_bmp, *enemic, *enemic_bmp,  *auraene_bmp, *auraene;

	

	long tick1, tick2; float dt;
	SDL_Event event;
	int	flags = 0;
	int keyDown=0; int bisagra=100;


	SDL_Init(SDL_INIT_VIDEO|SDL_INIT_AUDIO);
	
		atexit(SDL_Quit);

	SDL_ShowCursor(SDL_DISABLE);

	screen = SDL_SetVideoMode(SCREEN_W, SCREEN_H, 16, flags);

	credit_bmp = SDL_LoadBMP("./GPMM/atomigfx/ikaruga/credit.bmp"); credit = SDL_DisplayFormat(credit_bmp); SDL_FreeSurface(credit_bmp);


	fons_bmp = SDL_LoadBMP("./GPMM/atomigfx/ikaruga/nuvols.bmp"); fons = SDL_DisplayFormat(fons_bmp); SDL_FreeSurface(fons_bmp);
	font_bmp = SDL_LoadBMP("./GPMM/atomigfx/ikaruga/font.bmp");	font = SDL_DisplayFormat(font_bmp);	SDL_FreeSurface(font_bmp);	
	aura_bmp= SDL_LoadBMP("./GPMM/atomigfx/ikaruga/aura.bmp");	aura = SDL_DisplayFormat(aura_bmp);	SDL_FreeSurface(aura_bmp);	
	nau_bmp= SDL_LoadBMP("./GPMM/atomigfx/ikaruga/nau.bmp");	nau = SDL_DisplayFormat(nau_bmp);	SDL_FreeSurface(nau_bmp);	

	tiro_bmp= SDL_LoadBMP("./GPMM/atomigfx/ikaruga/tiro.bmp");	tiro = SDL_DisplayFormat(tiro_bmp);	SDL_FreeSurface(tiro_bmp);	
	tiron_bmp= SDL_LoadBMP("./GPMM/atomigfx/ikaruga/tiron.bmp");	tiron = SDL_DisplayFormat(tiron_bmp);	SDL_FreeSurface(tiron_bmp);	


	enemic_bmp= SDL_LoadBMP("./GPMM/atomigfx/ikaruga/enemic.bmp");	enemic = SDL_DisplayFormat(enemic_bmp);	SDL_FreeSurface(enemic_bmp);	

	auraene_bmp= SDL_LoadBMP("./GPMM/atomigfx/ikaruga/auraene.bmp");	auraene = SDL_DisplayFormat(auraene_bmp);	SDL_FreeSurface(auraene_bmp);	


SDL_SetAlpha(aura, SDL_SRCALPHA, 128);
SDL_SetAlpha(tiro, SDL_SRCALPHA, 200);

		
int x=150, y=150;
int tirosx[20];
int tirosy[20];
int tiross[20];
int i;
int tr=0,trv=2;
int plus=0;
int wait=0;
int enevida=5;
float diex=0,diey=0,dies=0;
float desx=0,desy=0;

for (i=0; i<20; i++)
	tiross[i]=0;
	
SDL_SetAlpha(auraene, SDL_SRCALPHA, 128);

float enex=320,eney=120; float dy=2;	

	while (SDL_PollEvent(&event) >= 0)
	{

	
	diex+=(desx-diex)/100;
	diey+=(desy-diey)/100;
if (diex>330) dies=0;

	
	if (enex>10)
	{
	enex-=4;
	eney= (((enex-140)*(enex-140))/700)+20;
	}else
	{
	if (dies==0)
	{
	diex=enex; diey=eney;
	dies=1;
	desx=x*3.5; desy=y*3.5;
	}
	enex=10;
	eney+=dy;
	
	
	if (eney<10) dy=2;
	if (eney>140) dy=-2;

	}
	tr+=trv;
	if (tr>65) trv=-2;
	if (tr<-65) trv=2;
	plus+=6;
	if (plus>1599) plus=0;
	wait--;
	SDL_SetAlpha(aura, SDL_SRCALPHA, 128+tr);
	SDL_SetAlpha(auraene, SDL_SRCALPHA, 128+(tr));

	DrawI(fons , screen, 1599-plus, 10, plus, 240, 0, 0);
	DrawI(fons , screen, 0,         10, 320-plus, 240, plus, 0);

	
	DrawI(aura , screen, 0, 0, 45, 45, x, y);
	DrawI(nau , screen, 0, 0, 20, 20, x+7, y+7);
	DrawI(auraene , screen, 0, 0, 30, 30, enex-14, eney+7);


	DrawI(enemic , screen, 0, 0, 63, 47, enex, eney);


for (i=0; i<20; i++)
{
	tirosx[i]-=6;
	if (tirosx[i]<0) tiross[i]=0; 
	if (tiross[i]==1)
	{ 	DrawI(tiro , screen, 0, 0, 40, 29, tirosx[i]+7, tirosy[i]+7);
	
	if ( (tirosx[i]>(enex-10)) && (tirosx[i]<(enex+10)) && (tirosy[i]>(eney-15)) && (tirosy[i]<(eney+15)))
	{
	enevida--;
	tiross[i]=0;
	}
	if (enevida==0)
	{
	enex=360; 
	enevida=5;
	}
		
	
	}
}	

		frame++;
		if (event.type == SDL_MOUSEBUTTONDOWN)
			break;

		Uint8 *keys;
		keys=SDL_GetKeyState(NULL);
	
  if(keys[SDLK_TAB]&&keys[SDLK_BACKSPACE])
  { return 0;
  }
  
  
  if(keys[SDLK_RIGHT])
  {
  x+=3; 
  }
   if(keys[SDLK_BACKSPACE] && keys[SDLK_TAB])
   return;
  if(keys[SDLK_LEFT])
  {
  x-=3; 
  }

  if(keys[SDLK_DOWN])
  {
  y+=3; 
  }

  if(keys[SDLK_UP])
  {
  y-=3; 
  }
  if(keys[SDLK_LALT])
  {
  if(wait<=0)
  {
  for (i=0; i<20; i++)
	{
	if (tiross[i]==0) {
				tirosx[i]=x;
				tirosy[i]=y;
				tiross[i]=1;
					wait=10;	

				goto out;
				}
	
	}
	}
  out:;
 }		DrawI(tiron , screen, 0, 0, 45, 45, diex, diey); 


DrawI(credit , screen, 0, 0, 320, 60, 0,240-60 );
char str[] = "thx you for playing gp atomic    thx Chui for gp32SDL    thx Andreas Wuest for the katomic gfx and levels      thx ilarri for spread gpatomic         thx all gp32 developers and users etc etc etc etc"; 

static p=-320;
p++;
if (p>1300) p=-320;

SDL_print2(&str[0],20-p,210,font, screen);

SDL_Flip(screen);
}
setCPUSpeed (66000000, 0x3a012, 0);

	exit(0);
}






/*----------------------------------------------------------
	EOF
----------------------------------------------------------*/
